<?php
require("../fpdf/fpdf.php");
include("functions.inc.php");
setlocale (LC_ALL, "de_DE@euro");

global $FPDF_FONTPATH;

$FPDF_FONTPATH="fonts/";
class PDF extends FPDF 
{
	function FancyTable($header,$data)
	{
	    //Colors, line width and bold font
	    $this->SetFillColor(255,0,0);
	    $this->SetTextColor(255);
	    $this->SetDrawColor(128,0,0);
	    $this->SetLineWidth(.3);
	    $this->SetFont('','B');
	    //Header
	    $w=array(40,35,40,45);
	    for($i=0;$i<count($header);$i++)
	        $this->Cell($w[$i],7,$header[$i],1,0,'C',1);
	    $this->Ln();
	    //Color and font restoration
	    $this->SetFillColor(224,235,255);
	    $this->SetTextColor(0);
	    $this->SetFont('');
	    //Data
	    $fill=0;
	    foreach($data as $row)
	    {
	        $this->Cell($w[0],6,$row[0],'LR',0,'L',$fill);
	        $this->Cell($w[1],6,$row[1],'LR',0,'L',$fill);
	        $this->Cell($w[2],6,number_format($row[2]),'LR',0,'R',$fill);
	        $this->Cell($w[3],6,number_format($row[3]),'LR',0,'R',$fill);
	        $this->Ln();
	        $fill=!$fill;
	    }
	    $this->Cell(array_sum($w),0,'','T');
	}


}






global $HTTP_GET_VARS;
$year = 0;
$month = 0;
$plan = array();
$buffer = array();

if($date = $HTTP_GET_VARS["date"])
{
	if(strlen($date)>10)
		die("Wrong date format");
	
	$date_array = explode("-",$date);

	if(!is_numeric($date_array[0]) || !is_numeric($date_array[1]))
		die("Wrong date format");
	
	$year = $date_array[0];
	$month = $date_array[1];
	
	if(!checkdate($month,1,$year))
		die("Wrong date format");

}
else
{
	$date_array = getdate();
	$month = $date_array["mon"];
	$year = $date_array["year"];
}
	

$date_start = mktime(0,0,0,$month,1,$year);
$date_end = mktime(0,0,0,$month+1,1,$year);


$date = $date_start;

while($date<$date_end)
{
	$date_array = getdate($date);
	if($date_array["wday"]==0 || $date_array["wday"]==6 || is_in_exceptions($date))
	{
		$buffer["FillColor"] = 200;
		$buffer["text"] = "---";
	}
	else
	{
		$buffer["FillColor"] = 255;
		$buffer["text"] = " ";
	}	
	$buffer["day"] = strftime("%d",$date);
	$buffer["wday"] = strftime("%a",$date);
	$plan[] = $buffer;
	
	$date += 86400;
}
	


setlocale(LC_NUMERIC,"en_US");
$pdf=new FPDF();
$pdf->Open();
$pdf->SetMargins(10,5);
$pdf->SetAutoPageBreak(false);
$pdf->AddPage();
$pdf->SetFont('Arial','B',14);



// Kopfzeile

$pdf->SetX(50);

$pdf->Cell(80,10,'Datensicherungsprotokoll ' . strftime('%B %Y',$date_start),0);
$pdf->Ln(10);

$pdf->SetFillColor(0);
$pdf->SetTextColor(255);

$pdf->SetFont('Arial','B',12);
// Ueberschriften
$pdf->Cell(8,5,' ',1,0,'C',1);
$pdf->Cell(10,5,' ',1,0,'C',1);
$pdf->Cell(30,5,'Band',1,0,'C',1);
$pdf->Cell(25,5,'Dateien',1,0,'C',1);
$pdf->Cell(25,5,'Kompress.-',1,0,'C',1);
$pdf->Cell(25,5,'Gre auf',1,0,'C',1);
$pdf->Cell(20,5,'Zeichen',1,0,'C',1);
$pdf->Cell(45,5,'Bemerkung',1,0,'C',1);

$pdf->Ln();
$pdf->Cell(8,5,' ',1,0,'C',1);
$pdf->Cell(10,5,' ',1,0,'C',1);
$pdf->Cell(30,5,' ',1,0,'C',1);
$pdf->Cell(25,5,'Anzahl',1,0,'C',1);
$pdf->Cell(25,5,'Faktor',1,0,'C',1);
$pdf->Cell(25,5,'Band',1,0,'C',1);
$pdf->Cell(20,5,' ',1,0,'C',1);
$pdf->Cell(45,5,' ',1,0,'C',1);


$pdf->Ln();



$pdf->SetTextColor(0);
$pdf->SetFont('Arial','',12);

foreach( $plan as $row)
{
	$pdf->SetFillColor($row["FillColor"]);
	$pdf->Cell(8,8,$row["day"],1,0,'C',1);
	$pdf->Cell(10,8,$row["wday"],1,0,'C',1);
	$pdf->Cell(30,8,$row["text"],1,0,'C',1);
	$pdf->Cell(25,8,$row["text"],1,0,'C',1);
	$pdf->Cell(25,8,$row["text"],1,0,'C',1);
	$pdf->Cell(25,8,' ',1,0,'C',1);
        $pdf->Cell(20,8,' ',1,0,'C',1);
	$pdf->Cell(45,8,' ',1,0,'C',1);

	$pdf->Ln();
}

$pdf->SetFillColor(255);
$pdf->Ln(20);
$pdf->SetFont('Arial','',10);
$pdf->Cell(135,4,"http://" . $_SERVER{'SERVER_NAME'} . $_SERVER{'SCRIPT_NAME'} . "?" . $_SERVER{'QUERY_STRING'},0,0,'L');
$pdf->Cell(4,4,strftime('Druck: %Y-%m-%d %T'),0,0,'L');



header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
header("Pragma: no-cache");
header("Cache-Control: no-store, no-cache, must-revalidate");
header("Cache-Control: post-check=0, pre-check=0", false);
$pdf->Output();

?>
