<?php
$EXCEPTIONS_PATH = "/etc/backup_exceptions"; # Wochentage, an denen nicht gesichert werden soll
$exceptions = array();


function read_exceptions()
{
	// liesst exceptions in ein globales Array
	global $exceptions;
	global $EXCEPTIONS_PATH;

	$fpointer = 0;
	$line = "";
	
	$fpointer = fopen($EXCEPTIONS_PATH,"r") or die("Kann folgende Datei nicht öffnen: $EXCEPTIONS_PATH");

	while(!feof($fpointer))
	{
		$exceptions[] = rtrim(fgets($fpointer,4096));
	
	}
		
	fclose($fpointer);

}



function is_in_exceptions($timestamp)
{
	// $timestamp muss als Unix-Timestamp (siehe mktime) vorliegen

	global $exceptions;
	
	if(count($exceptions) == 0)
	{	
		read_exceptions();
	}
		
	$date = array();
	$date_string = "";
		
	$date = getdate($timestamp);
	if(!checkdate($date["mon"],$date["mday"],$date["year"]))
		return false;
	
	$date_string = $date["year"] . "-" . sprintf("%02u",$date["mon"]) . "-" . sprintf("%02u",$date["mday"]);
	
	if(in_array($date_string,$exceptions))
	{
		return true;
	}	
	
	return false;
}


function type_of_backup($timestamp)
{
	// $timestamp muss als Unix-Timestamp (siehe mktime) vorliegen
	$date = array();
	$date_loop = array();
	
	$days_to_end_of_month = 0;
	$days_to_end_of_week = 0;
	$end_of_week = false;
	
	
	$date = getdate($timestamp);
	if(!checkdate($date["mon"],$date["mday"],$date["year"]))
		return "none";
	
	// keine Sicherung an Wochenenden
	if($date["wday"] == 0 || $date["wday"] == 6)
		return "none";

	if(is_in_exceptions($timestamp))
		return "none";

	$timestamp += 86400;
	$date_loop = getdate($timestamp);
	while ($date_loop["mon"] == $date["mon"])
	{
		if($date_loop["wday"] == 0)
			$end_of_week = true;
		
		if($date_loop["wday"] !=0 && $date_loop["wday"] != 6)
			{
				if(!is_in_exceptions($timestamp))
					{
						$days_to_end_of_month ++;
						if(!$end_of_week)
							$days_to_end_of_week ++;
					}
			}
		
		
		$timestamp += 86400; // 86400s = 1 day
		$date_loop = getdate($timestamp);
	}
	
	if($days_to_end_of_month==0)
		return "month";
	
	if($days_to_end_of_week==0)
		return "week";
	else
		return "day";
		
}

function next_backup_time($max_days = 365)
{
	$i = 0;
	$timestamp = time();

	while($i<=$max_days) 
	{
		$date = getdate($timestamp);

		if($date["wday"]!=6 && $date["wday"]!=0)
		{
			if(!is_in_exceptions($timestamp))
			{
				return $timestamp;
			}
		}

		$i++;
		$timestamp += 86400;
	}
	return false;
}


function output($ary)
{
	while (list($key,$val) = each($ary))
	{
		print  iconv("ISO-8859-1", "UTF-8",$val) . " <br> \r\n";

	}
}

function weekday($str)
{
	switch($str)
	{
		case 0:
			return "Son";
			break;
		case 1:
			return "Mon";
			break;
		case 2:
			return "Die";
			break;
		case 3:
			return "Mit";
			break;
		case 4:
			return "Don";
			break;
		case 5:
			return "Frei";
			break;
		case 6:
			return "Sam";
			break;
	}		
	
	return false;
}

function month_name($arg)
{
	switch($arg)
	{
		case 1:
			return "Januar";
			break;
		case 2:
			return "Februar";
			break;
		case 3:
			return "März";
			break;
		case 4:
			return "April";
			break;
		case 5:
			return "Mai";
			break;
		case 6:
			return "Juni";
			break;
		case 7:
			return "Juli";
			break;
		
		
		



	

	}
	return false;
}

?>
